# -*- coding: utf-8 -*-
# Generated by Django 1.11.9 on 2019-03-22 04:14
from __future__ import unicode_literals

from django.db import migrations, models
def init_model_code(model):
    from django_szuprefix.utils.datautils import auto_code
    for m in model.objects.select_for_update().all():
        if not m.code:
            m.code = auto_code(m.name)
            m.save()


def init_code(apps, schema_editor):
    for m in ('Category', 'Chapter', 'Course'):
        init_model_code(apps.get_model('course', m))


class Migration(migrations.Migration):

    dependencies = [
        ('saas', '0005_party_type'),
        ('course', '0005_auto_20190308_2010'),
    ]

    operations = [
        migrations.AlterField(
            model_name='category',
            name='code',
            field=models.CharField(blank=True, db_index=True, default='', max_length=64, verbose_name='\u62fc\u97f3\u7f29\u5199'),
        ),
        migrations.AlterField(
            model_name='chapter',
            name='code',
            field=models.CharField(blank=True, db_index=True, default='', max_length=64, verbose_name='\u62fc\u97f3\u7f29\u5199'),
        ),
        migrations.AlterField(
            model_name='course',
            name='code',
            field=models.CharField(blank=True, db_index=True, default='', max_length=64, verbose_name='\u62fc\u97f3\u7f29\u5199'),
        ),
        migrations.AlterUniqueTogether(
            name='course',
            unique_together=set([('party', 'name')]),
        ),
        migrations.RunPython(init_code)
    ]
