# -*- coding: utf-8 -*-
# Generated by Django 1.9.6 on 2017-09-05 06:08
from __future__ import unicode_literals

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import django_szuprefix.utils.modelutils


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Department',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=64, verbose_name='\u540d\u5b57')),
                ('order_num', models.PositiveSmallIntegerField(blank=True, default=0, verbose_name='\u5e8f\u53f7')),
                ('is_active', models.BooleanField(default=True, verbose_name='\u662f\u5426\u5728\u7528')),
                ('create_time', models.DateTimeField(auto_now_add=True, verbose_name='\u521b\u5efa\u65f6\u95f4')),
                ('modify_time', models.DateTimeField(auto_now=True, verbose_name='\u4fee\u6539\u65f6\u95f4')),
                ('parent', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='sub_departments', to='saas.Department', verbose_name='\u4e0a\u7ea7')),
            ],
            options={
                'verbose_name': '\u90e8\u95e8',
                'verbose_name_plural': '\u90e8\u95e8',
            },
        ),
        migrations.CreateModel(
            name='Party',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=128, verbose_name='\u540d\u79f0')),
                ('slug', models.CharField(blank=True, max_length=16, verbose_name='\u7f16\u53f7')),
                ('status', models.PositiveSmallIntegerField(choices=[(0, '\u6d4b\u8bd5\u4e2d'), (1, '\u6b63\u5f0f\u4f7f\u7528'), (2, '\u653e\u5f03'), (4, '\u505c\u6b62\u4f7f\u7528')], default=0, verbose_name='\u72b6\u6001')),
                ('is_active', models.BooleanField(default=True, verbose_name='\u6709\u6548')),
                ('worker_count', models.PositiveIntegerField(blank=True, default=0, verbose_name='\u7528\u6237\u89c4\u6a21')),
                ('create_time', models.DateTimeField(auto_now_add=True, verbose_name='\u521b\u5efa\u65f6\u95f4')),
                ('modify_time', models.DateTimeField(auto_now=True, verbose_name='\u4fee\u6539\u65f6\u95f4')),
            ],
            options={
                'verbose_name': '\u56e2\u4f53',
                'verbose_name_plural': '\u56e2\u4f53',
            },
        ),
        migrations.CreateModel(
            name='Worker',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('number', models.CharField(db_index=True, max_length=64, verbose_name='\u7f16\u53f7')),
                ('name', models.CharField(db_index=True, max_length=64, verbose_name='\u540d\u5b57')),
                ('position', models.CharField(blank=True, max_length=64, null=True, verbose_name='\u804c\u4f4d')),
                ('is_active', models.BooleanField(default=True, verbose_name='\u6709\u6548')),
                ('entrance_date', models.DateField(blank=True, null=True, verbose_name='\u52a0\u5165\u65e5\u671f')),
                ('quit_date', models.DateField(blank=True, null=True, verbose_name='\u9000\u51fa\u65e5\u671f')),
                ('profile', django_szuprefix.utils.modelutils.KeyValueJsonField(blank=True, null=True, verbose_name='\u6863\u6848')),
                ('create_time', models.DateTimeField(auto_now_add=True, verbose_name='\u521b\u5efa\u65f6\u95f4')),
                ('modify_time', models.DateTimeField(auto_now=True, verbose_name='\u4fee\u6539\u65f6\u95f4')),
                ('departments', models.ManyToManyField(blank=True, related_name='workers', to='saas.Department', verbose_name='\u90e8\u95e8')),
                ('party', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='workers', to='saas.Party', verbose_name='\u56e2\u4f53')),
                ('user', models.OneToOneField(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='as_saas_worker', to=settings.AUTH_USER_MODEL, verbose_name='user')),
            ],
            options={
                'verbose_name': '\u6210\u5458',
                'verbose_name_plural': '\u6210\u5458',
            },
        ),
        migrations.AddField(
            model_name='department',
            name='party',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='departments', to='saas.Party', verbose_name='\u56e2\u4f53'),
        ),
        migrations.AlterUniqueTogether(
            name='worker',
            unique_together=set([('party', 'number')]),
        ),
        migrations.AlterUniqueTogether(
            name='department',
            unique_together=set([('party', 'parent', 'name')]),
        ),
    ]
